; TOOL 01
; Version 1.0, Stand 24.09.2014
;

; -----------------------------------------
;
; Funktion: - Negation von V1 -> 0-V1

ASM_UP_NEG_V1:

        ; V1 wird in R2..R9 geladen
        MOV        R2,R16
        MOV        R3,R17
        MOV        R4,R18
        MOV        R5,R19
        MOV        R6,R20
        MOV        R7,R21
        MOV        R8,R22
        MOV        R9,R23

        ; R16..R23 wird auf 0 gesetzt
        CLR        R16
        CLR        R17
        CLR        R18
        CLR        R19
        CLR        R20
        CLR        R21
        CLR        R22
        CLR        R23

        ; 0 - V1 -> Ergebnis in V1
        SUB        R16,R2
        SBC        R17,R3
        SBC        R18,R4
        SBC        R19,R5
        SBC        R20,R6
        SBC        R21,R7
        SBC        R22,R8
        SBC        R23,R9

        RET



; -----------------------------------------
;
; Funktion: - Tauschen der beiden Variablen V1+V2

ASM_UP_CHG_V1V2:

; V1 <--> V2
        MOV        R2,R16
        MOV        R16,R24
        MOV        R24,R2

        MOV        R2,R17
        MOV        R17,R25
        MOV        R25,R2

        MOV        R2,R18
        MOV        R18,R26
        MOV        R26,R2

        MOV        R2,R19
        MOV        R19,R27
        MOV        R27,R2

        MOV        R2,R20
        MOV        R20,R28
        MOV        R28,R2

        MOV        R2,R21
        MOV        R21,R29
        MOV        R29,R2

        MOV        R2,R22
        MOV        R22,R30
        MOV        R30,R2

        MOV        R2,R23
        MOV        R23,R31
        MOV        R31,R2

        RET


; -----------------------------------------
;
; Funktion: - Addition der beiden Variablen V1+V2
;           - beide Variablen muessen positiv sein 

ASM_UP_ADD_V1V2:

; Addition von V1+V2 (beide positiv)
        ADD        R16, R24
        ADC        R17, R25
        ADC        R18, R26
        ADC        R19, R27
        ADC        R20, R28
        ADC        R21, R29
        ADC        R22, R30	
        ADC        R23, R31

        RET


; -----------------------------------------
;
; Funktion: - Subtraktion beiden Variablen V1-V2
;           - beide Variablen muessen positiv sein 

ASM_UP_SUB_V1V2:

; Subtraktion von V1-V2 (beide positiv)
        SUB        R16, R24
        SBC        R17, R25
        SBC        R18, R26
        SBC        R19, R27
        SBC        R20, R28
        SBC        R21, R29
        SBC        R22, R30	
        SBC        R23, R31

        RET




; -----------------------------------------
;
; Funktion: - Vergleich beiden Variablen V1-V2
;           - beide Variablen muessen positiv sein 

ASM_UP_VER_V1V2:

; Vergleich von V1-V2 (beide positiv)
        CP         R16, R24
        CPC        R17, R25
        CPC        R18, R26
        CPC        R19, R27
        CPC        R20, R28
        CPC        R21, R29
        CPC        R22, R30	
        CPC        R23, R31

        RET




; -----------------------------------------
;
; Funktion: - testen, ob Variable1 negativ ist
;           - wenn ja, wird R24 (V1_ist_negativ) true (=FF) 
;           - wenn nein, bleibt die Variable1 wie sie ist (eben positiv) 

ASM_UP_POS_V1:

; R24 wird als V1 genutzt
        PUSH       R24
        CLR        R24


        ; ist V1 negativ, so ist das Bit 7 im Register 23=1
        SBRS       R23,7       
        ; ist V1 negativ, so wird dieser Sprung uebersprungen
        RJMP       ASM_UP_POS_V1_A


; ab hier wurde erkannt, dass V1 negativ ist

        ; V1_ist_negativ und wird true -> FF 
        SER        R24

; V1 wird positiv, indem 0-V1 berechnet wird

        ; V1 wird in R2..R9 geladen
        MOV        R2,R16
        MOV        R3,R17
        MOV        R4,R18
        MOV        R5,R19
        MOV        R6,R20
        MOV        R7,R21
        MOV        R8,R22
        MOV        R9,R23

        ; R16..R23 wird auf 0 gesetzt
        CLR        R16
        CLR        R17
        CLR        R18
        CLR        R19
        CLR        R20
        CLR        R21
        CLR        R22
        CLR        R23

        ; 0 - V1 -> Ergebnis in V1
        SUB        R16,R2
        SBC        R17,R3
        SBC        R18,R4
        SBC        R19,R5
        SBC        R20,R6
        SBC        R21,R7
        SBC        R22,R8
        SBC        R23,R9

; ab hier ist V1 sicher positiv
ASM_UP_POS_V1_A:

        ; R0 ist die Variable -> V1_ist_negativ 
        MOV        R0,R24
        POP        R24


        RET




; -----------------------------------------
;
; Funktion: - testen, ob Variable2 negativ ist
;           - wenn ja, wird R16 (V2_ist_negativ) true (=FF) 
;           - wenn nein, bleibt die Variable2 wie sie ist (eben positiv) 

ASM_UP_POS_V2:

; R16 wird als V2 genutzt
        PUSH       R16
        CLR        R16


        ; ist V2 negativ, so ist das Bit 7 im Register 31=1
        SBRS       R31,7       
        ; ist V2 negativ, so wird dieser Sprung uebersprungen
        RJMP       ASM_UP_POS_V2_A


; ab hier wurde erkannt, dass V2 negativ ist

        ; V2_ist_negativ und wird true -> FF 
        SER        R16

; V2 wird positiv, indem 0-V2 berechnet wird

        ; V2 wird in R2..R9 geladen
        MOV        R2,R24
        MOV        R3,R25
        MOV        R4,R26
        MOV        R5,R27
        MOV        R6,R28
        MOV        R7,R29
        MOV        R8,R30
        MOV        R9,R31

        ; R24..R31 wird auf 0 gesetzt
        CLR        R24
        CLR        R25
        CLR        R26
        CLR        R27
        CLR        R28
        CLR        R29
        CLR        R30
        CLR        R31

        ; 0 - V2 -> Ergebnis in V2
        SUB        R24,R2
        SBC        R25,R3
        SBC        R26,R4
        SBC        R27,R5
        SBC        R28,R6
        SBC        R29,R7
        SBC        R30,R8
        SBC        R31,R9

; ab hier ist V2 sicher positiv
ASM_UP_POS_V2_A:

        ; R1 ist die Variable -> V2_ist_negativ 
        MOV        R1,R16
        POP        R16


        RET



; -----------------------------------------







