; TOOL 02
; Version 1.0, Stand 18.03.2015
;


; -----------------------------------------
;
; Funktion: - Modulo
; -----------------------------------------
;
;
ASM_UP_MOD_CURR_P1_P2:
; r16..r23 MOD r24..r31 = r16..r23

        SET
        RJMP    ASM_UP_MOD_DIV_CURR_P1_P2




; -----------------------------------------
;
; Funktion: - Division
; -----------------------------------------
;
;
ASM_UP_DIV_CURR_P1_P2:
; r16..r23 DIV r24..r31 = r16..r23

        CLT

ASM_UP_MOD_DIV_CURR_P1_P2:

        ; Loeschen von R2 und R3
        CLR     R2
        CLR     R3

        ; Loeschen von R4,R5, R6, R7, R8, R9
        MOVW    R4, R2
        MOVW    R6, R2
        MOVW    R8, R2

        ; Laden von R10 mit 64 (Schleifenzahl) 
        PUSH    R16
        LDI     R16, 64
        MOV     R10, R16
        POP     R16


ASM_UP_MOD_DIV_CURR_A:

        
        LSL     R16
        ROL     R17
        ROL     R18
        ROL     R19
        ROL     R20
        ROL     R21
        ROL     R22
        ROL     R23


        ROL     R2
        ROL     R3
        ROL     R4
        ROL     R5
        ROL     R6
        ROL     R7
        ROL     R8
        ROL     R9


        CP      R2, R24
        CPC     R3, R25
        CPC     R4, R26
        CPC     R5, R27
        CPC     R6, R28
        CPC     R7, R29
        CPC     R8, R30
        CPC     R9, R31

        BRCS    ASM_UP_MOD_DIV_CURR_B


        SUB     R2, R24
        SBC     R3, R25
        SBC     R4, R26
        SBC     R5, R27
        SBC     R6, R28
        SBC     R7, R29
        SBC     R8, R30
        SBC     R9, R31


        INC     R16


ASM_UP_MOD_DIV_CURR_B:

        DEC     R10


	BRNE    ASM_UP_MOD_DIV_CURR_A

        BRTC    ASM_UP_MOD_DIV_CURR_C

        MOVW    R16, R2
        MOVW    R18, R4
        MOVW    R20, R6
        MOVW    R22, R8


ASM_UP_MOD_DIV_CURR_C:


        RET




; -----------------------------------------
;
; Funktion: - Multiplikation
; r16..r23 * r24..r31 = r16..r23

ASM_UP_MUL_CURR_P1_P2:

        ; Loeschen R2, R3
        CLR        R2
        CLR        R3

	; Loeschen R4..R9
        MOVW       R4, R2
        MOVW       R6, R2
        MOVW       R8, R2

        ; Laden des Counters R10 mit 65
        PUSH       R16
        LDI        R16, 65
        MOV        R10, R16
        POP        R16

        ; Einspring in die Schleife
        RJMP       ASM_UP_MUL_CURR_D


ASM_UP_MUL_CURR_B:
        BRCC       ASM_UP_MUL_CURR_C
        ADD        R2, R24
        ADC        R3, R25
        ADC        R4, R26
        ADC        R5, R27
        ADC        R6, R28
        ADC        R7, R29
        ADC        R8, R30
        ADC        R9, R31

ASM_UP_MUL_CURR_C:
        ROR        R9
        ROR        R8
        ROR        R7
        ROR        R6
        ROR        R5
        ROR        R4
        ROR        R3
        ROR        R2

ASM_UP_MUL_CURR_D:
        ROR        R23
        ROR        R22
        ROR        R21
        ROR        R20
        ROR        R19
        ROR        R18
        ROR        R17
        ROR        R16

        DEC        R10

	BRNE	ASM_UP_MUL_CURR_B


        RET



; -----------------------------------------





