; Division von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 24.01.2013
;
; Uebergabe: R16 Divident Low
;            R17 Divident High
;            R18 Divisor Low
;            R19 Divisor High
; Ergebnis:  R16 Quotient Low
;            R17 Quotient High
;            R18 Rest Low 
;            R19 Rest High 
; Temporaere Register: R20,R21,R22


ASM_UP_MDIV16:

        LDI        R20, 16   ; 16 Schritte 

        MOV        R21, R18  ; R21 = Divisor Low
        MOV        R22, R19  ; R22 = Divisor High

        CLR        R18       ; R18 = Rest Low loeschen
        CLR        R19       ; R19 = Rest High loeschen
ASM_UP_MDIV16a:
			      
        LSL        R16       ; Divident Low links Quotient links Bit_0 <- 0   
        ROL        R17       ; Divident High
        ROL        R18       ; Rest Low
        ROL        R19       ; Rest High

        CP         R18, R21  ; Test Rest Low - Divisor Low
        CPC        R19, R22  ; Test Rest High - Divisor High

        BRLO       ASM_UP_MDIV16b   ; Rest < Divisor : Quotient Bit_0 bleibt 0

        SUB        R18, R21  ; Rest Low >= Divisor Low abziehen
        SBC        R19, R22  ; Rest High >= Divisor High abziehen

        INC        R16       ; Quotient Bit_0 wird 1
ASM_UP_MDIV16b:

        DEC        R20       ; Zaehler - 1
        BRNE       ASM_UP_MDIV16a   ; wiederhole 16 mal



        RET






