; Division von 2 32-Bit Zahlen (DWORD)
; Version 1.0, Stand 28.05.2013
;
; Uebergabe: R16 Divident D0
;            R17 Divident D1
;            R18 Divident D2
;            R19 Divident D3
;            R20 Divisor D0
;            R21 Divisor D1
;            R22 Divisor D2
;            R23 Divisor D3
;
;  Ergebnis: R16 Quotient D0
;            R17 Quotient D1
;            R18 Quotient D2
;            R19 Quotient D3
;            R20 Rest D0
;            R21 Rest D1
;            R22 Rest D2
;            R23 Rest D3
;
; Temporaere Register: R24,R25,R26,R27,R28


ASM_UP_MDIV32:

        LDI        R24, 32   ; 32 Schritte 

        MOV        R25, R20  ; R25 = Divisor D0
        MOV        R26, R21  ; R26 = Divisor D1
        MOV        R27, R22  ; R27 = Divisor D2
        MOV        R28, R23  ; R28 = Divisor D3

        CLR        R20       ; R20 = Rest D0 loeschen
        CLR        R21       ; R21 = Rest D1 loeschen
        CLR        R22       ; R22 = Rest D2 loeschen
        CLR        R23       ; R23 = Rest D3 loeschen

ASM_UP_MDIV32a:
			      
        LSL        R16       ; Divident D0 links Quotient links Bit_0 <- 0   
        ROL        R17       ; Divident D1
        ROL        R18       ; Divident D2
        ROL        R19       ; Divident D3
        ROL        R20       ; Rest D0
        ROL        R21       ; Rest D1
        ROL        R22       ; Rest D2
        ROL        R23       ; Rest D3

        CP         R20, R25  ; Test Rest D0 - Divisor D0
        CPC        R21, R26  ; Test Rest D1 - Divisor D1
        CPC        R22, R27  ; Test Rest D2 - Divisor D2
        CPC        R23, R28  ; Test Rest D3 - Divisor D3

        BRLO       ASM_UP_MDIV32b   ; Rest < Divisor : Quotient Bit_0 bleibt 0

        SUB        R20, R25  ; Rest D0 >= Divisor D0 abziehen
        SBC        R21, R26  ; Rest D1 >= Divisor D1 abziehen
        SBC        R22, R27  ; Rest D2 >= Divisor D2 abziehen
        SBC        R23, R28  ; Rest D3 >= Divisor D3 abziehen

        INC        R16       ; Quotient Bit_0 wird 1
ASM_UP_MDIV32b:

        DEC        R24       ; Zaehler - 1
        BRNE       ASM_UP_MDIV32a   ; wiederhole 32 mal



        RET






