; Division von 2 8-Bit Zahlen (BYTE)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 23.01.2013
;
; Uebergabe: R16 Divident
;            R18 Divisor
; Ergebnis:  R16 Quotient
;            R18 Rest 
; Temporaere Register: R20,R21


ASM_UP_MDIV8:
        LDI        R20, 8        ; 8 Schritte
        MOV        R21, R18      ; R21 = Divisor
        CLR        R18           ; R18 = Rest loeschen
ASM_UP_MDIV8a:
			      
        LSL        R16           ; Divident / Quotient links Bit_0 <- 0   
        ROL        R18           ; Rest links
        CP         R18, R21      ; Test Rest - Divisor
        BRLO       ASM_UP_MDIV8b ; Rest < Divisor : Quotient Bit_0 bleibt 0
        SUB        R18, R21      ; Rest >= Divisor abziehen
        INC        R16           ; Quotient Bit_0 wird 1
ASM_UP_MDIV8b:

        DEC        R20           ; Zaehler - 1
        BRNE       ASM_UP_MDIV8a ; wiederhole 8 mal


        RET






