; Division von 2 64-Bit Zahlen (Currency)
; Version 1.0, Stand 28.10.2014
;
; nach einer Veroeffentlichung
; in: http://www.avrfreaks.net/forum/c-util-efficient-64-bit-support
; Attachment(s): my64bit.zip
; Datei: dannis64bit.S
; Titel: AVR-GCC: Much better 64 bit support
; Author: Peter Dannegger
;
; Uebergabe: R16:R17:18:19:R20:R21:22:23 erster Faktor
;            R24:R25:26:27:R28:R29:30:31 zweiter Faktor
; Temporaere Register: R0..R9 
; R0, R1 = Boolean -> true = FF, false = 00
; R0 = V1_ist_negativ
; R1 = V2_ist_negativ


; -----------------------------------------
;
; Funktion: - Division von zwei Currency-Zahlen
;           - Vorzeichen werden beachtet
;           - alle temporaeren Register werden gesichert

ASM_UP_DIV_CURR:

; Retten der genutzten temporaeren Register

        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10

; testen, ob Variable1 (V1) negativ ist
; wenn ja wird sie positiv gesetzt und R24/R0 wird true

        RCALL      ASM_UP_POS_V1

        ; retten des Vorzeichenwetes
        PUSH       R0


; testen, ob Variable2 (V2) negativ ist
; wenn ja wird sie positiv gesetzt und R16/R1 wird true

        RCALL      ASM_UP_POS_V2

        ; retten des Vorzeichenwetes
        PUSH       R1


; der Divident muss mit 10000 multipliziert werden (Verschiebung des Komars)        
        PUSH       R24
        PUSH       R25
        PUSH       R26
        PUSH       R27
        PUSH       R28
        PUSH       R29
        PUSH       R30
        PUSH       R31


; Wert 10000 in V2
        LDI        R24,0x10
        LDI        R25,0x27
        LDI        R26,0x00
        LDI        R27,0x00
        LDI        R28,0x00
        LDI        R29,0x00
        LDI        R30,0x00
        LDI        R31,0x00


; Divident * 10000
        RCALL      ASM_UP_MUL_CURR_P1_P2


; zurueckholen des Divisors
        POP        R31
        POP        R30
        POP        R29
        POP        R28
        POP        R27
        POP        R26
        POP        R25
        POP        R24

; Division = Divident / Divisor
        RCALL      ASM_UP_DIV_CURR_P1_P2



; Auswerten der Vorzeichen und setzen des Vorzeichens des Ergebnisses
        POP        R1
        POP        R0

        CLR        R24

        CP         R0, R24

        BREQ       ASM_UP_DIV_CURR_X

        CP         R1, R24

; sind beide Vorzeichen gleich (++) dann Vorzeichen Ergebnis (+)
        BRNE       ASM_UP_DIV_CURR_Z

        RJMP       ASM_UP_DIV_CURR_Y

ASM_UP_DIV_CURR_X:

        CP         R1, R24

; sind beide Vorzeichen gleich (--) dann Vorzeichen Ergebnis (+)
        BREQ       ASM_UP_DIV_CURR_Z


ASM_UP_DIV_CURR_Y:

; sind die beiden Vorzeichen ungleich (-+) oder (+-) dann Vorzeichen Ergebnis (-)
        RCALL     ASM_UP_NEG_V1


ASM_UP_DIV_CURR_Z:



        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0


        RET










