; Subtraktion von 2 64-Bit Zahlen (Currency)
; Version 1.0, Stand 24.09.2014
;
; Uebergabe: R16:R17:18:19:R20:R21:22:23 erster Faktor
;            R24:R25:26:27:R28:R29:30:31 zweiter Faktor
; Temporaere Register: R0..R9 
; R0, R1 = Boolean -> true = FF, false = 00
; R0 = V1_ist_negativ
; R1 = V2_ist_negativ


; -----------------------------------------
;
; Funktion: - Subtraktion von zwei Currency-Zahlen
;           - Vorzeichen werden beachtet (auch mgliche Subtraktion) 
;           - alle temporaeren Register werden gesichert

ASM_UP_SUB_CURR:

; Retten der genutzten temporaeren Register

        PUSH       R0
        PUSH       R1

        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9

; testen, ob Variable1 (V1) negativ ist
; wenn ja wird sie positiv gesetzt und R24/R0 wird true

        RCALL      ASM_UP_POS_V1


; testen, ob Variable2 (V2) negativ ist
; wenn ja wird sie positiv gesetzt und R16/R1 wird true

        RCALL      ASM_UP_POS_V2


; nun werden die einzelnen Operationen nach dem Stand der beiden
; Vorzeichen ausgefuehrt

        CLR        R2
        CP         R0,R2
        BRNE       ASM_UP_SUB_CURR_A


        CP         R1,R2
        BRNE       ASM_UP_SUB_CURR_B



; V1 und V2 sind positiv -> d.h. es wird eine einfache Subtraktion ausgefuehrt -> V1-V2
        RCALL      ASM_UP_SUB_V1V2

        RJMP       ASM_UP_SUB_CURR_Z


; V1 ist negativ
ASM_UP_SUB_CURR_A:

        CP         R1,R2
        BRNE       ASM_UP_SUB_CURR_C


; V1 ist negativ, V2 ist positiv -> -V1-V2 = -(V1+V2)
        RCALL      ASM_UP_ADD_V1V2

        RCALL      ASM_UP_NEG_V1

        RJMP      ASM_UP_SUB_CURR_Z


; V1 ist positiv, V2 ist negativ -> V1--V2 = V1+V2
ASM_UP_SUB_CURR_B:
        RCALL      ASM_UP_ADD_V1V2

        RJMP       ASM_UP_SUB_CURR_Z


; V1 ist negativ, V2 ist negativ -> -V1--V2 = -V1+V2 = V2-V1
ASM_UP_SUB_CURR_C:
        RCALL      ASM_UP_CHG_V1V2

        RCALL      ASM_UP_SUB_V1V2



ASM_UP_SUB_CURR_Z:

        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2


        POP        R1
        POP        R0


        RET







