// mega128_Register.INC
// erstellt am 01.03.2020
// kontrolliert am 01.03.2020
// Signatur: 1e9702
// ATMEGA128 und ATMEGA128A haben die gleiche Signatur
// hat ByyteConReg und ByteConVar Register 




VAR

{
 Definitions marked "MEMORY MAPPED"are extended I/O ports
 and cannot be used with IN/OUT instructions
}




UCSR1C,
UDR1,
UCSR1A,
UCSR1B,
UBRR1H,
UBRR1L,
UCSR0C,
UBRR0H,
TCCR3C,
TCCR3A,
TCCR3B,
TCNT3L,
TCNT3H,
OCR3AL,
OCR3AH,
OCR3BL,
OCR3BH,
OCR3CL,
OCR3CH,
ICR3L,
ICR3H,
ETIMSK,
ETIFR,
TCCR1C,
OCR1CL,
OCR1CH,
TWCR,
TWDR,
TWAR,
TWSR,
TWBR,
OSCCAL,
XMCRA,
XMCRB,
EICRA,
SPMCSR,
PORTG,
DDRG,
PING,
PORTF,
DDRF

   : ByteConVar;



{
  alle Register, die mit In/OUT angesprochen werden koennen
}


SREG,
SPL,
SPH,
XDIV,
RAMPZ,
EICRB,
EIMSK,
EIFR,
TIMSK,
TIFR,
MCUCR,
MCUCSR,
TCCR0,
TCNT0,
OCR0,
ASSR,
TCCR1A,
TCCR1B,
TCNT1L,
TCNT1H,
OCR1AL,
OCR1AH,
OCR1BL,
OCR1BH,
ICR1L,
ICR1H,
TCCR2,
TCNT2,
OCR2,
OCDR,
WDTCR,
SFIOR,
EEARL,
EEARH,
EEDR,
EECR,
PORTA,
DDRA,
PINA,
PORTB,
DDRB,
PINB,
PORTC,
DDRC,
PINC,
PORTD,
DDRD,
PIND,
SPDR,
SPSR,
SPCR,
UDR0,
UCSR0A,
UCSR0B,
UBRR0L,
ACSR,
ADMUX,
ADCSRA,
ADCH,
ADCL,
PORTE,
DDRE,
PINE,
PINF

    : ByteConReg;



  UBRR0 : WordConVar;


  RXC0[UCSR0A,7] : Bit;
  TXC0[UCSR0A,6] : Bit;
  UDRE0[UCSR0A,5] : Bit;


{
OCR0, OCR2, TCCR0,
TCNT1, OCR1A, OCR1B
ICR1, EEAR, ADC : WordConReg;
}



// *** ISR-Liste ***
//
ISR_LISTE( 2,'INT0addr' ,'INT0'         ,'External Interrupt Request 0');
ISR_LISTE( 3,'INT1addr' ,'INT1'         ,'External Interrupt Request 1');
ISR_LISTE( 4,'INT2addr' ,'INT2'         ,'External Interrupt Request 1');

ISR_LISTE( 5,'PCI0addr' ,'PCINT0'       ,'Pin Change Interrupt Request 0');
ISR_LISTE( 6,'PCI1addr' ,'PCINT1'       ,'Pin Change Interrupt Request 1');
ISR_LISTE( 7,'PCI2addr' ,'PCINT2'       ,'Pin Change Interrupt Request 2');
ISR_LISTE( 8,'PCI3addr' ,'PCINT3'       ,'Pin Change Interrupt Request 3');

ISR_LISTE( 9,'WDTaddr'  ,'WDT'          ,'Watchdog Time-out Interrupt');

ISR_LISTE(10,'OC2Aaddr'  ,'TIMER2_COMPA','Timer/Counter2 Compare Match A');
ISR_LISTE(11,'OC2Baddr'  ,'TIMER2_COMPB','Timer/Counter2 Compare Match B');

ISR_LISTE(12,'OVF2addr' ,'TIMER2_OVF'   ,'Timer/Counter2 Overflow');

ISR_LISTE(13,'ICP1addr' ,'TIMER1_CAPT'  ,'Timer/Counter1 Capture Event');

ISR_LISTE(14,'OC1Aaddr' ,'TIMER1_COMPA' ,'Timer/Counter1 Compare Match A');
ISR_LISTE(15,'OC1Baddr' ,'TIMER1_COMPB' ,'Timer/Counter1 Compare Match B');

ISR_LISTE(16,'OVF1addr' ,'TIMER1_OVF'   ,'Timer/Counter1 Overflow');

ISR_LISTE(17,'OC0Aaddr' ,'TIMER1_COMPA' ,'Timer/Counter0 Compare Match A');
ISR_LISTE(18,'OC0Baddr' ,'TIMER1_COMPB' ,'Timer/Counter0 Compare Match B');

ISR_LISTE(19,'OVF0addr' ,'TIMER0_OVF'   ,'Timer/Counter0 Overflow');

ISR_LISTE(20,'SPIaddr'  ,'SPI_STC'      ,'Serial Transfer Complete');

ISR_LISTE(21,'URXC0addr','USART0_RXC'   ,'USART0, Rx Complete');
ISR_LISTE(22,'UDRE0addr','USART0_UDRE'  ,'USART0 Data Register Empty');
ISR_LISTE(23,'UTXC0addr','USART0_TXC'   ,'USART0, Tx Complete');

ISR_LISTE(24,'ACIaddr'  ,'ANA_COMP'     ,'Analog Comparator');
ISR_LISTE(25,'ADCCaddr' ,'ADC_CC'       ,'ADC Conversion Complete');

ISR_LISTE(26,'ERDYaddr' ,'EE_RDY'       ,'EEPROM Ready');

ISR_LISTE(27,'TWIaddr'  ,'TWI'          ,'Two-wire Serial Interface');
ISR_LISTE(28,'SPMRaddr' ,'SPM_RDY'      ,'Store Program Memory Ready');

ISR_LISTE(29,'URXC1addr','USART1_RXC'   ,'USART0, Rx Complete');
ISR_LISTE(30,'UDRE1addr','USART1_UDRE'  ,'USART0 Data Register Empty');
ISR_LISTE(31,'UTXC1addr','USART1_TXC'   ,'USART0, Tx Complete');

ISR_LISTE(32,'ICP3addr' ,'TIM3_CAPT'    ,'Timer/Counter3 Capture Event');

ISR_LISTE(33,'OC3Aaddr' ,'TIM3_COMPA'   ,'Timer/Counter3 Compare Match A');
ISR_LISTE(34,'OC3Baddr' ,'TIM3_COMPB'   ,'Timer/Counter3 Compare Match B');

ISR_LISTE(35,'OVF3addr' ,'TIM3_OVF'     ,'Timer/Counter3 Overflow');




